                                       ;
                    ; Programming Trivia V0.4.5.2 Pre-Alpha
                                       ;
        ; Authors:  Brandon Olivares <ph-webmaster@programmershaven.org>
               ; Project Website:  http://ptrivia.sourceforge.net
                                       ;
                                       ;
         ; A trivia game to test the knowledge and skill of programmers
          ; Copyright (C) 2004  Brandon Olivares, all rights reserved.
                                       ;
     ; This program is free software; you can redistribute it and/or modify
     ; it under the terms of the GNU General Public License as published by
      ; the Free Software Foundation; either version 2 of the License, or
                     ; (at your option) any later version.
                                       ;
       ; This program is distributed in the hope that it will be useful,
        ; but WITHOUT ANY WARRANTY; without even the implied warranty of
        ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
                 ; GNU General Public License for more details.
                                       ;
      ; You should have received a copy of the GNU General Public License
         ; along with this program; if not, write to the Free Software
  ; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
                                       ;
                                       ;
      ; To contact us, send an e-mail to ph-webmaster@programmershaven.org
                                       ;
                                       ;
                                ; categories.asm
                                       ;
                         ; Main file for categories.dll
                 ; This DLL controls the categories dialog box
                                       ;


.486
.model flat, stdcall
option casemap:none

include windows.inc						; Windows constants and structures
include \masm32\macros\macros.asm		; Macros for masm
include user32.inc						; include file for functionality in
										; user32.lib
include kernel32.inc					; Functions from kernel32.lib
include advapi32.inc					; For the registry functions
includelib user32.lib					; User32 library
includelib kernel32.lib					; kernel32 library
includelib advapi32.lib					; For the registry functions
include categories.inc					; Categories header file


                                       ;
                                  ; dialogProc
                                       ;
                                       ;
                          ; Callback procedure for the
                              ; categories dialog
                                       ;
                                       ;
                                 ; Parameters:
                          ; hWnd:HWND - Dialog handle
                    ; msg:UINT - Message sent to the dialog
                      ; wParam:WPARAM - Extra message data
                       ; lParam:LPARAM - More extra data
                                       ;
                                       ;
                                ; Return value:
                  ; If the message is processed by the dialog,
                                ; returns true.
                          ; Otherwise, returns false.
                                       ;
dialogProc proto hWnd:HWND,msg:UINT,wParam:WPARAM,lParam:LPARAM


                                       ;
                            ; addCategoryDialogProc
                                       ;
                                       ;
                  ; Procedure for the dialog to add a category
                                       ;
                                       ;
                                 ; Parameters:
                          ; hWnd:HWND - Dialog handle
                    ; msg:UINT - Message sent to the dialog
                      ; wParam:WPARAM - Extra message data
                       ; lParam:LPARAM - More extra data
                                       ;
                                       ;
                                ; Return value:
                  ; If the message is processed by the dialog,
                                ; returns true.
                          ; Otherwise, returns false.
                                       ;
addCategoryDialogProc proto hWnd:HWND,msg:UINT,wParam:WPARAM,lParam:LPARAM

.data				; Data for this program

                                                ; ------------------------------
                                                    ; Path to the categories key
                                                                             ; -
hKeyName db "Software\Programmers' Haven\Programming Trivia\categories",0

errorMsg db 256 dup (0)				; Buffer for error messages
errorMsgSize dd 256
errorTitle db "Error",0

lpValueName dd 50 dup (0)				; Name of the subkey
cbValueSize dd 50						; size of subkey name

noCategorySelected db "You must select a category",0			; If no category
																; is selected

.data?
hInstance HINSTANCE ?				; DLL instance
mainWindow HWND ?

.code

                                       ;
                                   ; dllEntry
                                       ;
                                       ;
                              ; Main DLL procedure
                                       ;
                                       ;
                                 ; Parameters:
                        ; hInst:HINSTANCE - DLL instance
                 ; reason:DWORD - Specifies when it was called
                          ; reserved1:DWORD - Reserved
                                       ;
                                       ;
                                ; Return value:
                           ; Returns true on success
                                       ;
DllEntry proc hInst:HINSTANCE,reason:DWORD,reserved1:DWORD
	
	mov eax, hInst				; Storing instance into global hInstance
	mov hInstance,eax

	mov eax, TRUE						; Return true
	ret

DllEntry endp


                                       ;
                            ; displayCategoryDialog
                                       ;
                                       ;
                      ; Displays the categories dialog box
                                       ;
                                       ;
                                 ; Parameters:
                          ; hWnd:HWND - Window handle
                                       ;
                                       ;
                                ; Return value:
                               ; Always returns 0
                                       ;
displayCategoryDialog proc hWnd:HWND
	
	mov eax, hWnd
	mov mainWindow, eax
	
	invoke DialogBoxParam,hInstance,IDD_CATEGORIES,hWnd,addr dialogProc,0

	xor eax, eax						; Return 0
	ret

displayCategoryDialog endp



                                       ;
                                  ; dialogProc
                                       ;
                                       ;
                          ; Callback procedure for the
                              ; categories dialog
                                       ;
                                       ;
                                 ; Parameters:
                          ; hWnd:HWND - Dialog handle
                    ; msg:UINT - Message sent to the dialog
                      ; wParam:WPARAM - Extra message data
                       ; lParam:LPARAM - More extra data
                                       ;
                                       ;
                                ; Return value:
                  ; If the message is processed by the dialog,
                                ; returns true.
                          ; Otherwise, returns false.
                                       ;
dialogProc proc hWnd:HWND,msg:UINT,wParam:WPARAM,lParam:LPARAM

	LOCAL createResult:DWORD;				; Was the key created or opened?
	LOCAL hKey:HKEY;						; Handle to the key
	LOCAL enumCount:DWORD
	LOCAL catIndex:DWORD				; Category index in list box


	mov eax, msg				; Store message into eax for quick access

	cmp eax, WM_INITDIALOG				; When the dialog is created
	je wminitdialog
	cmp eax,WM_CLOSE				; Closing the dialog
	je wmclose
	cmp eax, WM_COMMAND				; Message from a control
	je wmcommand

	xor eax, eax				; No message processed, return false
	ret

  wminitdialog:				; Dialog was created, initialize it

                                                ; ------------------------------
                                   ; First, open (or create) the categories key,
                                                     ; retrieving a handle to it
                                                ; ------------------------------

	invoke RegCreateKeyEx,HKEY_CURRENT_USER, addr hKeyName, NULL, NULL,\
	REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,addr hKey, addr createResult

	cmp eax, ERROR_SUCCESS
	jne isInvalidKey

                                                ; ------------------------------
                                       ; Enumerate through the values within the
                                         ; categories key.  Send to the list box
                                                           ; We begin at index 0
                                                ; ------------------------------

xor ecx, ecx				; Start at index 0

  beginEnumKeyLoop:

	mov enumCount, ecx

	invoke RegEnumValue, hKey, ecx, addr lpValueName, addr cbValueSize, NULL,\
	NULL, NULL, NULL

	cmp eax, ERROR_SUCCESS						; Valid key
	je errorsuccess
	cmp eax, ERROR_NO_MORE_ITEMS				; No more items
	je errornomoreitems

	invoke FormatMessage,FORMAT_MESSAGE_FROM_SYSTEM,NULL,eax, NULL,\
	addr errorMsg, errorMsgSize, NULL

	invoke MessageBox,hWnd,addr errorMsg, addr errorTitle,\
	MB_OK OR MB_ICONEXCLAMATION
	jmp endEnumKeyLoop

  errorsuccess:				; The key is ok

                                                ; ------------------------------
                                 ; Send the retrieved value name to the list box
                                                ; ------------------------------

	invoke SendDlgItemMessage,hWnd,IDD_CATLIST, LB_ADDSTRING, 0,addr lpValueName


	mov cbValueSize, 50		; Set size to 50; RegenumValue changes the size,
							; so we have to reset it

	mov ecx, enumCount
	inc ecx
	jmp beginEnumKeyLoop

  errornomoreitems:				; No more items

  endEnumKeyLoop:

	invoke RegCloseKey, hKey

	jmp endMsgCompare

  wmclose:				; Closing the dialog
	invoke EndDialog,hWnd,0				; End the dialog, returning 0
	jmp endMsgCompare

  wmcommand:				; Message from a control
	mov eax, wParam				; Move wParam into eax for quick access
	and eax, 0000FFFFh				; clear out H.O. word

	cmp eax, IDOK				; OK button was pressed
	je idok
	cmp eax, IDCANCEL				; Cancel button was pressed
	je idcancel
	cmp eax, IDD_REMOVE_CATEGORY				; Remove a category
	je iddremove
	cmp eax, IDD_ADD_CATEGORY				; Add a category
	je iddaddcategory
	jmp endMsgCompare

  idok:				; OK button
	invoke SendMessage,hWnd,WM_CLOSE,0,0				; Close the dialog box
	jmp endMsgCompare

  idcancel:				; Cancel button
	invoke SendMessage,hWnd,WM_CLOSE,0,0				; Close the dialog box
	jmp endMsgCompare

  iddremove:				; remove a category

                                                ; ------------------------------
                             ; Send the LB_GETCURSEL message to check which item
                                    ; is selected, if any.  If none is selected,
                                           ; pop up a message box with an error.
                                                ; ------------------------------

	invoke SendDlgItemMessage,hWnd,IDD_CATLIST,LB_GETCURSEL,0,0
                                                ; ------------------------------
                                                    ; Index is now in eax, or if
                                                   ; nothing is selected, LB_ERR
                                                ; ------------------------------

	cmp eax, LB_ERR				; Is anything selected?
	je nothingSelected

                                                ; ------------------------------
                                                ; store the index, then retrieve
                                                       ; the string of that item
                                                ; ------------------------------

	mov catIndex, eax

	invoke SendDlgItemMessage,hWnd,IDD_CATLIST, LB_GETTEXT,catIndex,\
	addr lpValueName

                                                ; ------------------------------
                                        ; open up the key handle to the registry
                                                ; ------------------------------

	invoke RegCreateKeyEx,HKEY_CURRENT_USER, addr hKeyName, NULL, NULL,\
	REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,addr hKey, addr createResult

	cmp eax, ERROR_SUCCESS				; created successfully?
	jne isInvalidKey				; See the bottom of this procedure


                                                ; ------------------------------
                                            ; Delete the value from the registry
                                                ; ------------------------------
	invoke RegDeleteValue, hKey, addr lpValueName


	push eax				; the call might change eax
	invoke RegCloseKey, hKey
	pop eax


                                                ; ------------------------------
                                   ; Varify that the key was deleted.  If it was
          ; ERROR_SUCCESS will be in eax.  Otherwise, we print the error message
                                                ; ------------------------------

	cmp eax, ERROR_SUCCESS
	jne notSuccess

                                                ; ------------------------------
                                        ; Now delete this item from the list box
                                                ; ------------------------------

	invoke SendDlgItemMessage,hWnd,IDD_CATLIST,LB_DELETESTRING,catIndex,0


	invoke GetDlgItem,hWnd,IDD_CATLIST			; Set focus to list box
	invoke SetFocus,eax

jmp endMsgCompare


  iddaddcategory:

                                                ; ------------------------------
                                           ; Create the add category dialog box,
                                 ; passing the address to lpValueName to put the
                                                      ; new category's name into
                                                ; ------------------------------

invoke MessageBox,hWnd,addr errorTitle,addr errorTitle,MB_OK

	invoke DialogBoxParam,hInstance, IDD_ADDDLG, hWnd,
	addr addCategoryDialogProc,0

	invoke MessageBox,hWnd,addr lpValueName,addr errorTitle,MB_OK

  endMsgCompare:

	mov eax, TRUE						; Return true
	ret



                                                ; ------------------------------
                                                     ; Some labels that are used
                                                         ; throughout the dialog
                                                ; ------------------------------
  
  isInvalidKey:				; Key is invalid

	invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, NULL, eax, NULL,\
	addr errorMsg, errorMsgSize, NULL

	invoke MessageBox,hWnd,addr errorMsg, addr errorTitle,\
	MB_OK OR MB_ICONEXCLAMATION


	invoke GetDlgItem,hWnd,IDD_CATLIST			; Set focus to list box
	invoke SetFocus,eax


	jmp endMsgCompare


  notSuccess:				; couldn't delete the value

                                                ; ------------------------------
                                         ; Call FormatMessage to get the message
                                                                  ; of the error
                                                ; ------------------------------


	invoke FormatMessage,FORMAT_MESSAGE_FROM_SYSTEM,NULL,eax,NULL,\
	addr errorMsg, errorMsgSize, NULL

	invoke MessageBox, hWnd, addr errorMsg, addr errorTitle,\
	MB_OK OR MB_ICONEXCLAMATION

	invoke GetDlgItem,hWnd,IDD_CATLIST			; Set focus to list box
	invoke SetFocus,eax


	jmp endMsgCompare



  nothingSelected:				; No value selected

                                                ; ------------------------------
                                              ; No category selected, show error
                                                ; ------------------------------
	invoke MessageBox,hWnd,addr noCategorySelected,addr errorTitle,\
	MB_OK OR MB_ICONEXCLAMATION

	invoke GetDlgItem,hWnd,IDD_CATLIST
	invoke SetFocus,eax

	jmp endMsgCompare


dialogProc endp


                                       ;
                            ; addCategoryDialogProc
                                       ;
                                       ;
                  ; Procedure for the dialog to add a category
                                       ;
                                       ;
                                 ; Parameters:
                          ; hWnd:HWND - Dialog handle
                    ; msg:UINT - Message sent to the dialog
                      ; wParam:WPARAM - Extra message data
                       ; lParam:LPARAM - More extra data
                                       ;
                                       ;
                                ; Return value:
                  ; If the message is processed by the dialog,
                                ; returns true.
                          ; Otherwise, returns false.
                                       ;
addCategoryDialogProc proc hWnd:HWND,msg:UINT,wParam:WPARAM,lParam:LPARAM

	mov eax, msg				; Store ms ginto eax for quick access

	cmp eax, WM_CLOSE				; Closing the dialog box
	je wmclose
	cmp eax, WM_COMMAND				; Message from a control
	je wmcommand
	jmp endMsgCompare

	xor eax, eax
	ret

  wmclose:				; Close the dialog box
	invoke EndDialog,hWnd,0
	jmp endMsgCompare

  wmcommand:				; message from a control
	mov eax, wParam				; get the control identifier
	and eax, 0000FFFFh				; Clear H.O. word of eax

	cmp eax, IDOK				; OK button was pressed
	je idok
	cmp eax, IDCANCEL
	je idcancel
	jmp endMsgCompare

  idok:
	jmp endMsgCompare

  idcancel:				; Cancel button
	invoke SendMessage,hWnd,WM_CLOSE,0,0

  endMsgCompare:

	mov eax, TRUE
	ret

addCategoryDialogProc endp

end DllEntry
